// A workin new/delte example with MeMirko Sdk
//

//  standard includes
#include <string.h>
#include <stdio.h>

//  c++ includes
#include "gp32.h"
#include "cpp_prototypes.h"
#include "cpp.h"


//#define CPP_INHERITANCE_ERROR

#ifdef  CPP_INHERITANCE_ERROR

class basis {
public:
  int wert;
   basis() {}
   basis(int _wert) {wert=_wert;}
   virtual int get_private() { return wert;}
};

class plum : public basis{
public:
plum(int _wert) {wert=_wert;}
   int get_private() { return wert * 30;}
};

#endif


int cpp_main()
{
  
#ifdef  CPP_INHERITANCE_ERROR
  basis *pluto = new plum(300);
  int i = pluto->get_private();
  delete pluto;  
#endif

  gp_initRTC();
  gp_initFramebuffer((u32)FRAMEBUFFER1,16,85);
  gp_clearRTC();

  int color=0;
  while(true)
  {
    ++color;
    
    if (gp_getButton()&BUTTON_A)
      gp_Reset();
      
    if (gp_getButton()&BUTTON_SELECT)
    {
      u16* myNew = new u16[320*240];
      memset(myNew,color,320*240*2);
      memcpy((void*)FRAMEBUFFER1,myNew,320*240*2);
      delete[]myNew;
    }
    else
    {
      gp_clearFramebuffer16((u16*)FRAMEBUFFER1,0xffff);
    }
  }
}